import type { AbstractColDef, BeanCollection, ComponentSelector } from '@ag-grid-community/core';
import { Component } from '@ag-grid-community/core';
import type { ToolPanelFiltersCompParams } from './filtersToolPanel';
export type AgFiltersToolPanelListEvent = 'filterExpanded' | 'groupExpanded';
export declare class AgFiltersToolPanelList extends Component<AgFiltersToolPanelListEvent> {
    private toolPanelColDefService;
    private columnModel;
    wireBeans(beans: BeanCollection): void;
    private initialised;
    private hasLoadedInitialState;
    private isInitialState;
    private params;
    private filterGroupComps;
    private searchFilterText;
    private suppressOnColumnsChanged;
    private onColumnsChangedPending;
    constructor();
    init(params: ToolPanelFiltersCompParams): void;
    onColumnsChanged(): void;
    syncFilterLayout(): void;
    private buildTreeFromProvidedColumnDefs;
    setFiltersLayout(colDefs: AbstractColDef[]): void;
    private recreateFilters;
    private recursivelyAddComps;
    private refreshAriaLabel;
    private recursivelyAddFilterGroupComps;
    private filtersExistInChildren;
    private shouldDisplayFilter;
    private getExpansionState;
    refresh(): void;
    setVisible(visible: boolean): void;
    expandFilterGroups(expand: boolean, groupIds?: string[]): void;
    expandFilters(expand: boolean, colIds?: string[]): void;
    private onGroupExpanded;
    private onFilterExpanded;
    private fireExpandedEvent;
    performFilterSearch(searchText: string): void;
    private searchFilters;
    private setFirstAndLastVisible;
    private refreshFilters;
    getExpandedFiltersAndGroups(): {
        expandedGroupIds: string[];
        expandedColIds: string[];
    };
    private destroyFilters;
    destroy(): void;
}
export declare const AgFiltersToolPanelListSelector: ComponentSelector;
