import type { AgColumn, AgProvidedColumnGroup, BeanCollection, ITooltipParams, WithoutGridCommon } from '@ag-grid-community/core';
import { Component } from '@ag-grid-community/core';
import { ToolPanelFilterComp } from './toolPanelFilterComp';
export type ToolPanelFilterItem = ToolPanelFilterGroupComp | ToolPanelFilterComp;
export declare class ToolPanelFilterGroupComp extends Component {
    private columnNameService;
    wireBeans(beans: BeanCollection): void;
    private filterGroupComp;
    private readonly depth;
    private readonly columnGroup;
    private readonly showingColumn;
    private childFilterComps;
    private expandedCallback;
    private filterGroupName;
    constructor(columnGroup: AgColumn | AgProvidedColumnGroup, childFilterComps: (ToolPanelFilterGroupComp | ToolPanelFilterComp)[], expandedCallback: () => void, depth: number, showingColumn: boolean);
    postConstruct(): void;
    private setupTooltip;
    getTooltipParams(): WithoutGridCommon<ITooltipParams>;
    addCssClassToTitleBar(cssClass: string): void;
    refreshFilters(isDisplayed: boolean): void;
    isColumnGroup(): boolean;
    isExpanded(): boolean;
    getChildren(): ToolPanelFilterItem[];
    getFilterGroupName(): string;
    getFilterGroupId(): string;
    hideGroupItem(hide: boolean, index: number): void;
    hideGroup(hide: boolean): void;
    private addInIcon;
    private forEachToolPanelFilterChild;
    private addExpandCollapseListeners;
    private getColumns;
    private addFilterChangedListeners;
    private refreshFilterClass;
    private onFilterOpened;
    expand(): void;
    collapse(): void;
    private setGroupTitle;
    private getColumnGroupName;
    private getColumnName;
    private destroyFilters;
    destroy(): void;
}
